# Siemens RTL Tiled Window Manager

## what is it?

RTL is a tiled window manager created for the X11R2/3 engine in 1988. it uses libraries like X10 (or liboldx nowadays), and aside from that I'd recommend installing the entire X11 development kit (well, not counting acceleration libraries), including ``imake``.

## what changes did you make, exactly?

well, a tiny tweak to the ``input.c`` file, fixing a very specific compiler quirk that seemed to break the thing. I initialised the ``union wait`` structure with a single integer variable, as that's the size that's expected to be passed in the vague ``wait3`` call below. i tested it, and it works fine with the modern X.Org implementations, so no worries. you don't need to pass any weird compiler flags anymore.

## how do you add things to the Tools menu?

ah, you just follow this format in the ``~/.rtl.tools`` file:

```
Label
    command
```

for each tool you just add another entry like this. personally, I have it store this:

```
UXTerm
    uxterm
Console
    xconsole
Clock
    xclock
Calculator
    xcalc
```

## is it worth it in the modern day?

mmmmm, not really, it's just my love for the late 80's - early 90's computing aesthetics.

## where did you even find this?

I have two sources to cite: for one, [this page](http://www.xwinman.org/others.php) brought its existence to my attention; and for two, [this forum post](https://dev.suckless.narkive.com/ZzbkXSfA/siemens-rtl-tiled-window-manager) gave me a mostly patched source.

## Screenshots

![demo1](./screenshots/rtl-example.png)
