/*
 * Copyright 1988 by Siemens Research and Technology Laboratories, Princeton, NJ
 *
 *                         All Rights Reserved
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of Siemens Research and Technology
 * Laboratories not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission.
 *
 *
 * SIEMENS DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * SIEMENS BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */
#include "copyright.h"


#include "basetype.h"

bool ACCEPT_NON_LISTENER_IN_BODY;
bool ACCEPT_NON_LISTENER_IN_BORDER;
bool ACCEPT_NON_LISTENER_IN_GADGET;
bool ACCEPT_NON_LISTENER_IN_HEADER;

bool ALLOW_AGGRESIVE_REPOPULATION;

bool ALLOW_ANY_SHRINK_ON_AUTO_REPOP;
bool ALLOW_ANY_SHRINK_ON_EXPL_REPOP;

bool ALLOW_AUTOMATIC_SHRINK_BY_CLIENT;
bool ALLOW_AUTOMATIC_CLOSE_BY_CLIENT;

bool ALLOW_LISTENER_TO_CLOSE;
bool ALLOW_LSNR_TO_CHANGE_BY_CLIENT;
bool ALLOW_LSNR_TO_CLOSE_BY_CLIENT;

bool AUTO_DESIRED_ENLARGE;

bool AUTO_PLACE_ON_ICON_OPEN;
bool AUTO_PLACE_ON_MENU_OPEN;
bool AUTO_PLACE_ON_UNSIZED_OPEN;

bool AUTO_PRORATE;
bool AUTO_PRORATE_LOCALLY;

bool AUTO_REPOPULATE_LAST;
bool AUTO_REPOPULATE_ON_AUTO_UNZOOM;
bool AUTO_REPOPULATE_ON_CLOSE;
bool AUTO_REPOP_ON_DESKTOP_RESIZE;
bool AUTO_REPOP_ON_EXPLICIT_UNZOOM;

bool ALLOW_SHRINK_ON_AUTO_OPEN;
bool ALLOW_SHRINK_ON_CENTER_OPEN;
bool ALLOW_SHRINK_ON_CORNER_OPEN;
bool ALLOW_SHRINK_ON_RESIZE;

bool BEST_FIT;

bool BUTTON_MAKES_LISTENER_IN_BODY;
bool BUTTON_MAKES_LISTENER_IN_HEADER;

bool CENTER_CURSOR_ON_MOVE;
bool CENTER_CURSOR_ON_RELOCATE;

bool CLEAR_BODY_ON_REDRAW;

bool CLOSE_IN_HEADER;
bool CLOSE_IN_CORNER_BORDER;
bool CLOSE_IN_SIDE_BORDER;
bool CLOSE_IN_MOVE_GADGET;
bool CLOSE_IN_ZOOM_GADGET;

bool DISTINGUISH_CORNER_BORDERS;
bool DISTNGSH_CORNER_BORDERS_BY_INV;

bool DRAW_INNER_BORDERS;
bool DRAW_OUTER_BORDERS;

bool DRAW_X_ON_MOVE;
bool DRAW_X_ON_OPEN;
bool DRAW_X_ON_RESIZE;

bool EXCHANGE_IN_HEADER;
bool EXCHANGE_IN_CORNER_BORDER;
bool EXCHANGE_IN_SIDE_BORDER;
bool EXCHANGE_IN_ZOOM_GADGET;

bool EXCHANGE_SIZES_IF_POSSIBLE;

bool FULL_SCREEN;

Side ICON_PLACEMENT;

bool INCL_BGRND_MENU_IN_WINDOW_MENU;

bool KEY_MAKES_LISTENER_IN_BODY;
bool KEY_MAKES_LISTENER_IN_BORDER;
bool KEY_MAKES_LISTENER_IN_GADGET;
bool KEY_MAKES_LISTENER_IN_HEADER;

bool FOCUS_FOLLOWS_CURSOR;

bool LOCAL_AUTO_PRORATE_BIASED;
bool LOCAL_EXPLICIT_PRORATE_BIASED;

bool MANAGER_MENU_IN_BODY;
bool MANAGER_MENU_IN_CORNER_BORDER;
bool MANAGER_MENU_IN_HEADER;
bool MANAGER_MENU_IN_ICON;
bool MANAGER_MENU_IN_SIDE_BORDER;

bool MIDDLE_MENU;

bool MOVE_CURSOR_ON_CLIENT_OPEN;
bool MOVE_CURSOR_ON_MANUAL_OPEN;
bool MOVE_CURSOR_TO_ICON_ON_CLOSE;

bool MOVE_IN_HEADER;
bool MOVE_IN_CORNER_BORDER;
bool MOVE_IN_SIDE_BORDER;
bool MOVE_IN_ZOOM_GADGET;

bool ONLY_REPOP_SINCE_ON_AUTO_UNZOOM;
bool ONLY_REPOPULATE_SINCE_ON_CLOSE;
bool ONLY_REPOP_SINCE_ON_EXPL_UNZOOM;

bool PLACE_CSR_IN_BODY_NOT_GADGET;

bool PLACE_CSR_GDGT_AFT_CL_AUTO_OPEN;
bool PLACE_CSR_GDGT_AFT_US_AUTO_OPEN;
bool PLACE_CSR_IN_GADGET_AFT_MAN_OPEN;

bool PLACE_CSR_IN_GADGET_AFT_EXCHANGE;
bool PLACE_CSR_IN_GADGET_AFT_MOVE;

bool PLACE_CSR_BACK_ON_CANCEL;

bool PREFER_CL_TO_SHR_ON_AUTO_OPEN;
bool PREFER_CL_TO_SHR_ON_CENTER_OPEN;
bool PREFER_CL_TO_SHR_ON_CORNER_OPEN;
bool PREFER_CL_TO_SHR_ON_RESIZE;

bool PREFER_PREV_POS_ON_AUTO_REPOP;
bool PREFER_PREV_POS_ON_EXPL_REPOP;

bool PF_CTR_NBR_2_CLOSE_ON_OPEN;
bool PF_CTR_NBR_2_SHRINK_ON_OPEN;
bool PF_CTR_NBR_2_ANY_SHR_ON_OPEN;
bool PF_EDGE_NBR_2_CLOSE_ON_OPEN;
bool PF_EDGE_NBR_2_SHRINK_ON_OPEN;
bool PF_EDGE_NBR_2_ANY_SHR_ON_OPEN;

bool PF_DTOP_2_CLOSE_ON_AUTO_OPEN;
bool PF_DTOP_2_SHRINK_ON_AUTO_OPEN;
bool PF_DTOP_2_ANY_SHR_ON_AUTO_OPEN;

bool PREF_SLD_TO_CLOSE_ON_RESIZE;
bool PREF_SLD_TO_SHRINK_ON_RESIZE;
bool PREF_SLD_TO_ANY_SHR_ON_RESIZE;
bool PF_CTR_NBR_2_CLOSE_ON_RESIZE;
bool PF_CTR_NBR_2_SHRINK_ON_RESIZE;
bool PF_CTR_NBR_2_ANY_SHR_ON_RESIZE;
bool PF_EDGE_NBR_2_CLOSE_ON_RESIZE;
bool PF_EDGE_NBR_2_SHRINK_ON_RESIZE;
bool PF_EDGE_NBR_2_ANY_SHR_ON_RESIZE;

bool PREFER_UNZOOM_TO_CLOSE;

bool PRORATE_LOCALLY;

bool REDRAW_IN_HEADER;
bool REDRAW_IN_CORNER_BORDER;
bool REDRAW_IN_SIDE_BORDER;
bool REDRAW_IN_MOVE_GADGET;
bool REDRAW_IN_ZOOM_GADGET;

bool RELOCATE_IN_HEADER;
bool RELOCATE_IN_CORNER_BORDER;
bool RELOCATE_IN_SIDE_BORDER;
bool RELOCATE_IN_ZOOM_GADGET;

bool REQUIRE_PREV_POS_ON_AUTO_REPOP;
bool REQUIRE_PREV_POS_ON_EXPL_REPOP;

bool RESET_MAX_ON_INCREASE;
bool RESET_MAX_ON_SHRINK;

bool RESET_MIN_ON_DECREASE;
bool RESET_MIN_ON_ENLARGE;
bool RESET_MIN_MAX_ON_UNSZD_MAN_OPEN;
bool RESET_TIED_ZOOMED_MIN_ON_ENLARGE;

bool RESIZE_IN_HEADER;
bool RESIZE_IN_CORNER_BORDER;
bool RESIZE_IN_SIDE_BORDER;
bool RESIZE_IN_MOVE_GADGET;
bool RESIZE_IN_ZOOM_GADGET;

bool SHOW_LISTENER_IN_BORDERS;
bool SHOW_LISTENER_IN_HEADER;
bool SHOW_FOCUS_IN_BORDERS;
bool SHOW_FOCUS_IN_HEADER;

bool TREAT_MOVE_LIKE_RELOCATE;

bool TRY_CTR_NBRHD_ON_OPEN;
bool TRY_EDGE_NEIGHBORHOOD_ON_OPEN;

bool TRY_SLIDING_ON_RESIZE;
bool TRY_CTR_NBRHD_ON_RESIZE;
bool TRY_EDGE_NEIGHBORHOOD_ON_RESIZE;

bool TRY_REPOP_AGAIN_AFT_AUTO_PRORATE;

bool UNZOOM_TIED_LSNR_IF_NECESSARY;

bool USE_CORNER_BORDERS;

bool USE_ICONS;
bool USE_RTL_ICON;

bool USER_MENU_IN_BODY;
bool USER_MENU_IN_HEADER;
bool USER_MENU_IN_SIDE_BORDER;
bool USER_MENU_IN_CORNER_BORDER;
bool USER_MENU_IN_ICON;

bool ZOOM_IN_HEADER;
bool ZOOM_IN_CORNER_BORDER;
bool ZOOM_IN_SIDE_BORDER;

bool ZOOM_ON_CREATE;
