/*
static char sccs_id[] = "@(#)useroptsP.h	5.4  9/1/88";
*/

/*
 * Copyright 1988 by Siemens Research and Technology Laboratories, Princeton, NJ
 *
 *                         All Rights Reserved
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of Siemens Research and Technology
 * Laboratories not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission.
 *
 *
 * SIEMENS DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * SIEMENS BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */


typedef enum {

    ACCEPT_NON_LISTENER_IN_BODY,
    ACCEPT_NON_LISTENER_IN_BORDER,
    ACCEPT_NON_LISTENER_IN_GADGET,
    ACCEPT_NON_LISTENER_IN_HEADER,

    ALLOW_AGGRESSIVE_REPOPULATION,

    ALLOW_AUTO_SHRINK_ON_AUTO_REPOP,
    ALLOW_AUTO_SHRINK_ON_EXPL_REPOP,

    ALLOW_AUTO_SHRINK_ON_EXCHANGE,
    ALLOW_AUTO_CLOSE_ON_EXCHANGE,

    ALLOW_AUTOMATIC_SHRINK_BY_CLIENT,
    ALLOW_AUTOMATIC_CLOSE_BY_CLIENT,

    ALLOW_LISTENER_TO_CLOSE,
    ALLOW_LSNR_TO_CHANGE_BY_CLIENT,
    ALLOW_LSNR_TO_CLOSE_BY_CLIENT,

    ALLOW_SHRINK_ON_AUTO_OPEN,
    ALLOW_SHRINK_ON_CENTER_OPEN,
    ALLOW_SHRINK_ON_CORNER_OPEN,
    ALLOW_SHRINK_ON_RESIZE,

    AUTO_DESIRED_ENLARGE,

    AUTO_PLACE_ON_ICON_OPEN,
    AUTO_PLACE_ON_MENU_OPEN,
    AUTO_PLACE_ON_UNSIZED_OPEN,

    AUTO_PRORATE,
    AUTO_PRORATE_LOCALLY,

    AUTO_REPOPULATE_LAST,
    AUTO_REPOPULATE_ON_AUTO_UNZOOM,
    AUTO_REPOPULATE_ON_CLOSE,
    AUTO_REPOP_ON_DESKTOP_RESIZE,
    AUTO_REPOP_ON_EXPLICIT_UNZOOM,

    BIASED_AUTO_PRORATE,
    BIASED_EXPLICIT_PRORATE,

    BUTTON_MAKES_LISTENER_IN_BODY,
    BUTTON_MAKES_LISTENER_IN_HEADER,

    CENTER_CURSOR_ON_MOVE,
    CENTER_CURSOR_ON_RELOCATE,

    CLEAR_BODY_ON_REDRAW,

    CLOSE_IN_HEADER,
    CLOSE_IN_CORNER_BORDER,
    CLOSE_IN_SIDE_BORDER,
    CLOSE_IN_MOVE_GADGET,
    CLOSE_IN_ZOOM_GADGET,

    DESIRE_IN_HEADER,
    DESIRE_IN_CORNER_BORDER,
    DESIRE_IN_SIDE_BORDER,
    DESIRE_IN_MOVE_GADGET,
    DESIRE_IN_ZOOM_GADGET,

    DISTINGUISH_CORNER_BORDERS,
    DISTNGSH_CORNER_BORDERS_BY_INV,

    DRAW_X_ON_MOVE,
    DRAW_X_ON_OPEN,
    DRAW_X_ON_RESIZE,

    ENABLE_AUTO_REPOP_DURING_LAYOUT,    
    ENABLE_AUTO_SIZING_DURING_LAYOUT,    

    ENLARGE_IN_HEADER,
    ENLARGE_IN_CORNER_BORDER,
    ENLARGE_IN_SIDE_BORDER,
    ENLARGE_IN_MOVE_GADGET,
    ENLARGE_IN_ZOOM_GADGET,

    EXCHANGE_IN_HEADER,
    EXCHANGE_IN_ICON,
    EXCHANGE_IN_CORNER_BORDER,
    EXCHANGE_IN_SIDE_BORDER,
    EXCHANGE_IN_MOVE_GADGET,
    EXCHANGE_IN_ZOOM_GADGET,

    FULL_SCREEN,

    INCL_BGRND_MENU_IN_WINDOW_MENU,

    KEY_MAKES_LISTENER_IN_BODY,
    KEY_MAKES_LISTENER_IN_BORDER,
    KEY_MAKES_LISTENER_IN_GADGET,
    KEY_MAKES_LISTENER_IN_HEADER,

    FOCUS_FOLLOWS_CURSOR,

    MANAGER_MENU_IN_BODY,
    MANAGER_MENU_IN_CORNER_BORDER,
    MANAGER_MENU_IN_HEADER,
    MANAGER_MENU_IN_ICON,
    MANAGER_MENU_IN_SIDE_BORDER,
    MANAGER_MENU_IN_MOVE_GADGET,
    MANAGER_MENU_IN_ZOOM_GADGET,

    MIDDLE_MENU,

    MOVE_CURSOR_ON_CLIENT_OPEN,
    MOVE_CURSOR_ON_MANUAL_OPEN,
    MOVE_CURSOR_TO_ICON_ON_CLOSE,

    MOVE_IN_HEADER,
    MOVE_IN_ICON,
    MOVE_IN_CORNER_BORDER,
    MOVE_IN_SIDE_BORDER,
    MOVE_IN_MOVE_GADGET,
    MOVE_IN_ZOOM_GADGET,

    ONLY_REPOP_SINCE_ON_AUTO_UNZOOM,
    ONLY_REPOPULATE_SINCE_ON_CLOSE,
    ONLY_REPOP_SINCE_ON_EXPL_UNZOOM,

    PLACE_CSR_IN_BODY_NOT_BORDER,
    PLACE_CSR_IN_BODY_NOT_GADGET,

    PLACE_CSR_IN_BORDER_AFTER_RESIZE,

    PLACE_CSR_GDGT_AFT_CL_AUTO_OPEN,
    PLACE_CSR_GDGT_AFT_US_AUTO_OPEN,
    PLACE_CSR_IN_GADGET_AFT_MAN_OPEN,

    PLACE_CSR_IN_GADGET_AFT_EXCHANGE,
    PLACE_CSR_IN_GADGET_AFT_MOVE,

    PLACE_CSR_IN_ICON_AFTER_CLOSE,

    PLACE_CSR_BACK_AFTER_MENU_OP,
    PLACE_CSR_BACK_ON_CANCEL,

    PREFER_CL_TO_SHR_ON_AUTO_OPEN,
    PREFER_CL_TO_SHR_ON_CENTER_OPEN,
    PREFER_CL_TO_SHR_ON_CORNER_OPEN,
    PREFER_CL_TO_SHR_ON_EXCHANGE,
    PREFER_CL_TO_SHR_ON_RESIZE,

    PREFER_EXC_LOC_ON_ICONIZING,
    PREFER_EXCHANGED_LOC_ON_OPENING,

    PREFER_PREV_POS_ON_AUTO_REPOP,
    PREFER_PREV_POS_ON_EXPL_REPOP,

    PF_CTR_NBR_2_AUTO_CL_ON_OPEN,
    PF_CTR_NBR_2_AUTO_SHR_ON_OPEN,
    PF_CTR_NBR_2_SHRINK_ON_OPEN,
    PF_EDGE_NBR_2_AUTO_CL_ON_OPEN,
    PF_EDGE_NBR_2_AUTO_SHR_ON_OPEN,
    PF_EDGE_NBR_2_SHRINK_ON_OPEN,

    PF_DTOP_2_AUTO_CL_ON_AUTO_OPEN,
    PF_DTOP_2_AUTO_SHR_ON_AUTO_OPEN,
    PF_DTOP_2_SHRINK_ON_AUTO_OPEN,

    PREF_SLD_TO_AUTO_CL_ON_RESIZE,
    PREF_SLD_TO_AUTO_SHR_ON_RESIZE,
    PREF_SLD_TO_SHRINK_ON_RESIZE,
    PF_CTR_NBR_2_AUTO_CL_ON_RESIZE,
    PF_CTR_NBR_2_AUTO_SHR_ON_RESIZE,
    PF_CTR_NBR_2_SHRINK_ON_RESIZE,
    PF_EDGE_NBR_2_AUTO_CL_ON_RESIZE,
    PF_EDGE_NBR_2_AUTO_SHR_ON_RESIZE,
    PF_EDGE_NBR_2_SHRINK_ON_RESIZE,

    PREFER_UNZOOM_TO_CLOSE,

    PRORATE_LOCALLY,

    REDRAW_IN_HEADER,
    REDRAW_IN_ICON,
    REDRAW_IN_CORNER_BORDER,
    REDRAW_IN_SIDE_BORDER,
    REDRAW_IN_MOVE_GADGET,
    REDRAW_IN_ZOOM_GADGET,

    RELOCATE_IN_HEADER,
    RELOCATE_IN_CORNER_BORDER,
    RELOCATE_IN_SIDE_BORDER,
    RELOCATE_IN_MOVE_GADGET,
    RELOCATE_IN_ZOOM_GADGET,

    REPOPULATE_STRICTLY,
    REPOPULATE_AUTO_CLOSED_ONLY,

    REQUIRE_PREV_POS_ON_AUTO_REPOP,
    REQUIRE_PREV_POS_ON_EXPL_REPOP,

    RESET_MAX_ON_INCREASE,
    RESET_MAX_ON_SHRINK,

    RESET_MIN_ON_DECREASE,
    RESET_MIN_ON_ENLARGE,
    RESET_MIN_MAX_ON_UNSZD_MAN_OPEN,
    RESET_TIED_ZOOMED_MIN_ON_ENLARGE,

    RESET_ZOOM_MIN,
    RESET_ZOOM_MIN_ALLOWS_DECREASE,
    RESET_ZOOM_MIN_USES_DESIRE,

    RESIZE_IN_HEADER,
    RESIZE_IN_CORNER_BORDER,
    RESIZE_IN_SIDE_BORDER,
    RESIZE_IN_MOVE_GADGET,
    RESIZE_IN_ZOOM_GADGET,

    SHOW_LISTENER_IN_BORDERS,
    SHOW_LISTENER_IN_HEADER,
    SHOW_FOCUS_IN_BORDERS,
    SHOW_FOCUS_IN_HEADER,

    TREAT_MOVE_LIKE_RELOCATE,

    TRY_CTR_NBRHD_ON_EXCHANGE,

    TRY_CTR_NBRHD_ON_OPEN,
    TRY_EDGE_NEIGHBORHOOD_ON_OPEN,

    TRY_SLIDING_ON_RESIZE,
    TRY_CTR_NBRHD_ON_RESIZE,
    TRY_EDGE_NEIGHBORHOOD_ON_RESIZE,

    TRY_REPOP_AGAIN_AFT_AUTO_PRORATE,

    UNZOOM_TIED_LSNR_IF_NECESSARY,

    USE_CORNER_BORDERS,

    USE_ICON_AREA,
    USE_ICONS,
    USE_RTL_ICON,

    USER_MENU_IN_BODY,
    USER_MENU_IN_HEADER,
    USER_MENU_IN_SIDE_BORDER,
    USER_MENU_IN_CORNER_BORDER,
    USER_MENU_IN_ICON,
    USER_MENU_IN_MOVE_GADGET,
    USER_MENU_IN_ZOOM_GADGET,

    ZOOM_IN_HEADER,
    ZOOM_IN_CORNER_BORDER,
    ZOOM_IN_SIDE_BORDER,
    ZOOM_IN_MOVE_GADGET,
    ZOOM_IN_ZOOM_GADGET,

    ZOOM_ON_CREATE,

    LENGTH_USER_GLOBAL_OPTIONS
} User_Global_Options;
